# Radix Sort

Tugas OpenMPI - Radix Sort. Praktikum2_K02_13516128_13516032

## Petunjuk penggunaan program

1. Buka terminal, jalankan make
```
$ make
  ```
2. Untuk menjalankan program, jalankan
```
$ ./radix_sort <N> dengan N adalah jumlah elemen array
```

## Pembagian tugas

| NIM      | Nama          | Tugas                              |
| -------- | ------------- | ---------------------------------- |
| 13516032 | Ridho Pratama | radix sort, cuda          |
| 13516155 | Restu Wahyu Kartiko | Testing, input output, readme |

## Laporan

### Deskripsi solusi paralel
Algoritma radix sort yang digunakan disini agak berbeda dengan radix sort yang ada di contoh. Jika di contoh penjelasan tugas algoritma radix sort mengurutkan berdasarkan nilai tiap digit, disini yang kami gunakan adalah dengan mengurutkan tiap bit pada representasi binary setiap elemen array. 

- Pertama kami menentukan flag bit ke i pada setiap elemen array (0 atau 1) 
- Membuat array baru, reverse flag. Jika nilai pada flag 1, maka pada reverse bernilai 0, dan sebaliknya
- Menghitung histogram kemunculan bit 0 dan 1
- Membuat prefix sum untuk flag dan reverse flag
- Menentukan index baru untuk setiap elemen pada array
- Index baru ditentukan dengan menambahkan nilai histogram untuk nilai bit ke i elemen ke j array dengan prefix sum reverse flag ke j.

Proses paralel dilakukan saat perhitungan flag, reverse flag, prefix sum, histogram, dan perhitungan index baru.

### Analisis solusi

Solusi sekarang memungkinkan program untuk menjalankan sorting lebih cepat dibandingkan dengan proses serial. Hal ini akan di jelaskan pada tabel di bab selanjutnya. 
Perhitungan flag, reverse flag, prefix sum, dan perhitungan index baru dapat dipercepat dengan dijalankan secara paralel. Namun, untuk perhitungan histogram, walaupun pada implementasi dilakukan secara paralael, namun sebenernya mirip dengan dilakukan secara serial karena menggunakan atomic add dari CUDA dimana fungsi tersebut menambahkan nilai pada sebuat resource global tanpa boleh diganggu dengan proses lain. Jika kita bisa benar-benar memparalelkan proses perhitungan histogram, maka proses akan berjalan sedikit lebih cepat.
Selain itu, ada satu cara lagi untuk mempercepat proses pengurutan radix sort. Jika pada algoritma yang kami gunakan, pencarian flag dilaukan pada tiap bit. Jika kita bisa melakukan pencarian flag sekali langsung 2 atau 4 bit, maka proses akan menjadi lebih cepat karena iterasi akan berkurang.

#### Jumlah thread per block 
##### Pengujian dengan 5000 data
.
| p   | Percobaan 1 | Percobaan 2 | Percobaan 3 | Avg        |
| --- | ----------- | ----------- | ----------- | ---------- |
| 1   | 9388756     | 9540459     | 9801868     | 9577027.67 |
| 2   | 8321433     | 9714896     | 10681952    | 9572760.33 |
| 4   | 8370137     | 8375228     | 8404319     | 8383228    |
| 8   | 9385675     | 9405848     | 9554137     | 9448553.33 |

Dari data diatas, untuk pengukuran kerja kami menggunakan jumlah thread 4 karena terlihat lebih maksimal.


#### Pengukuran kinerja
Berikut adalah hasil dari pengukuran kinerja dengan jumlah elemen 5.000, 50.000, 100.000, 200.000, dan 400.000. Setiap pengujian dilakukan sebanyak 3 kali dan dihitung rata-ratanya. 


| N       | Percobaan 1 | Percobaan 2 | Percobaan 3 | Avg       | Serial    | Speedup |
| ------- | ----------- | ----------- | ----------- | --------- | --------- | ------- |
| 5.000   | 8148786     | 8157402     | 8182279     | 8162822.33| 9388756   | 1.15    |
| 50.000  | 9945857     | 9942933     | 9966641     | 9951810.33| 10249821  | 1.03    |
| 100.000 | 10308169    | 10312216    | 10320996    |10313793.67| 10911577  | 1.06    |
| 200.000 | 10917660    | 10925651    | 10885625    |10909645.33| 12662192  | 1.161   |
| 400.000 | 11425132    | 11419351    | 11433364    | 11425949  | 14206280  | 1.24    |

#### Analisis perbandingan kinerja
Pada percobaan yang telah kami lakukan, proses speed pada tiap percobaan dengan N kecil (5000) hingga N besar (400000) menunjukan performa parlel lebih bagus dari performa serial. Selain itu, nilai speedup yang didapan cenderung naik ketika nilai N juga semakin besar.

Dan juga efisiensi. 
Hal ini dikarenakan peningkatan ``T``<sub>overhead</sub> lebih kecil dibandingkan dengan ``T``<sub>serial</sub>.


### References
- Slide kuliah IF3230 Sistem Terdistribusi
- https://stackoverflow.com/questions/26206544/parallel-radix-sort-how-would-this-implementation-actually-work-are-there-some
